unit uPSDBTreeView.Main;

interface

uses
  System.SysUtils, System.Classes, Vcl.Controls, Vcl.ExtCtrls,
  FireDAC.Stan.Intf, FireDAC.Stan.Option, FireDAC.Stan.Error, FireDAC.UI.Intf,
  FireDAC.Phys.Intf, FireDAC.Stan.Def, FireDAC.Stan.Pool,
  FireDAC.Stan.Async, FireDAC.Phys, FireDAC.VCLUI.Wait, Data.DB,
  FireDAC.Comp.Client,vcl.dialogs,

  //my

  uPSDBTreeView.MC;

type
TOnCopyCut=procedure (AIDSelectedArray:Tarray<integer>  ) of object;

type
TOnFocus = procedure (ASender:TObject) of object;

type
  TPSDBTreeView = class(TPanel)
  private
    { Private declarations }

    FDBName:string;
    FDBTable:string;

    FDBFields:TDBFields;
    FIsUseExternalID:boolean;
    Fexternal_id_value:Integer;
    FFDConnection:TFDConnection;


    Fid:string;
    FidParent:string;
    Fname:string;
    FsortIndex:string;
    FisFolder:string;
    FisTrash:string;
    FisChecked:string;
    Fexternal_id:string;

    FOnCopyCut:TOnCopyCut;
    FOnFocus:TOnFocus;

    FMC:TPSDBTreeViewMC;

    procedure SetDBTable(const Value: string);
    procedure SetDBName(const Value: string);
    procedure SetDBFields(const Value: TDBFields);
    procedure SetExternal_id_value(const Value: Integer);
    procedure SetIsUseExternalID(const Value: Boolean);
    procedure setFFDConnection(const Value: TFDConnection);
    procedure SetID(const Value: string);
    procedure SetIDParent(const Value: string);
    procedure SetNameField(const Value: string);
    procedure SetSortIndexField(const Value: string);
    procedure SetisFolderField(const Value: string);
    procedure SetFisTrashField(const Value: string);
    procedure SetisCheckedField(const Value: string);
    procedure SetFexternal_idField(const Value: string);
    function getDBTable: string;
    procedure SetOnCopyCut(const Value: TOnCopyCut);
    procedure SetOnFocus(const Value: TOnFocus);





  protected
    { Protected declarations }
  public
    { Public declarations }
   constructor Create(AOwner: TComponent); override;
   destructor  destroy; override;






 // main methods
    procedure InitialSetup;
    procedure InitialUpdate;
    procedure DeleteCheckedOrSelected;
    procedure AddFolder(AName:string);
    procedure AddFile(AName:string);
    procedure NodeUp;
    procedure NodeDown;
    procedure Copy;
    procedure Cut;
    procedure Paste;
    procedure ClearAllPointers;
    procedure Rename(ANewName:string);


 property  MC:TPSDBTreeViewMC read FMC write FMC;
 property  OnCopyCut:TOnCopyCut read FOnCopyCut write SetOnCopyCut;
 property  OnFocus:TOnFocus read FOnFocus write SetOnFocus;

published
//    property DBFields:TDBFields read FDBFields write SetDBFields;

    property IsUseExternalID:Boolean read FIsUseExternalID write SetIsUseExternalID;
    property External_id_value:Integer read Fexternal_id_value write SetExternal_id_value;
    property DBName:string read FDBName write SetDBName;
    property DBTable:string read FDBTable write SetDBTable;
    property FDConnection:TFDConnection read FFDConnection write setFFDConnection;


    property id_field:string read Fid write SetID;
    property idParent_field:string read FidParent write SetIDParent;
    property name_field:string read Fname write SetNameField;
    property sortIndex_field:string read FsortIndex write SetSortIndexField;
    property isFolder_field:string read FisFolder write SetisFolderField;
    property isTrash_field:string read FisTrash write SetFisTrashField;
    property isChecked_field:string read FisChecked write SetisCheckedField;
    property external_id_field:string read Fexternal_id write SetFexternal_idField;


  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Samples', [TPSDBTreeView]);
end;

{ TPSDBTreeView }

procedure TPSDBTreeView.AddFile(AName: string);
begin
fmc.AddFile(AName);
end;

procedure TPSDBTreeView.AddFolder(AName: string);
begin
fmc.AddFolder(AName);
end;

procedure TPSDBTreeView.ClearAllPointers;
begin
fmc.ClearAllPointers;
end;

procedure TPSDBTreeView.Copy;
begin
fmc.Copy;
end;

constructor TPSDBTreeView.Create(AOwner: TComponent);
begin
  inherited;

    FDBFields:=TDBFields.Create(Self);
    FDBFields.SetSubComponent(true);

    FMC:=TPSDBTreeViewMC.Create(Self);

end;


procedure TPSDBTreeView.Cut;
begin
FMC.Cut;
end;

procedure TPSDBTreeView.DeleteCheckedOrSelected;
begin
FMC.DeleteCheckedOrSelected;
end;

destructor TPSDBTreeView.destroy;
begin
//FMC.Delete.ClearAllPointers;
///  FMC.Checkboxes.UncheckAllChecked;
  inherited;
end;


function TPSDBTreeView.getDBTable: string;
begin

end;

procedure TPSDBTreeView.InitialSetup;
begin
fmc.InitialSetup;
end;

procedure TPSDBTreeView.InitialUpdate;
begin
fmc.InitialUpdate;
end;

procedure TPSDBTreeView.NodeDown;
begin
fmc.NodeDown;
end;

procedure TPSDBTreeView.NodeUp;
begin
fmc.NodeUp;
end;

procedure TPSDBTreeView.Paste;
begin
fmc.Paste;
end;

procedure TPSDBTreeView.Rename(ANewName: string);
begin
fmc.Rename(ANewName);
end;

procedure TPSDBTreeView.SetDBFields(const Value: TDBFields);
begin
  FMC.DBFields := Value;
  showmessage('Hello');
end;

procedure TPSDBTreeView.SetDBName(const Value: string);
begin
  FMC.DBName := Value;
end;

procedure TPSDBTreeView.SetDBTable(const Value: string);
begin
FMC.DBTable:=Value;
end;

procedure TPSDBTreeView.SetExternal_id_value(const Value: Integer);
begin
 FMC.external_id_value := Value;
end;

procedure TPSDBTreeView.SetFexternal_idField(const Value: string);
begin
 fmc.DBFields.external_id := Value;
end;

procedure TPSDBTreeView.setFFDConnection(const Value: TFDConnection);
begin
 fmc.FDConnection := Value;
end;

procedure TPSDBTreeView.SetisFolderField(const Value: string);
begin
 fmc.DBFields.isFolder:= Value;
end;

procedure TPSDBTreeView.SetFisTrashField(const Value: string);
begin
 fmc.DBFields.isTrash := Value;
end;

procedure TPSDBTreeView.SetID(const Value: string);
begin
 fmc.DBFields.id := Value;
end;

procedure TPSDBTreeView.SetIDParent(const Value: string);
begin
 FMC.DBFields.idParent := Value;
end;

procedure TPSDBTreeView.SetisCheckedField(const Value: string);
begin
 fmc.DBFields.isChecked := Value;
end;


procedure TPSDBTreeView.SetIsUseExternalID(const Value: Boolean);
begin
fmc.IsUseExternalID := Value;
end;

procedure TPSDBTreeView.SetNameField(const Value: string);
begin
fmc.DBFields.name := Value;
end;

procedure TPSDBTreeView.SetOnCopyCut(const Value: TOnCopyCut);
begin
FMC.CopyCutPaste.OnCopyCut:=Value;
end;

procedure TPSDBTreeView.SetOnFocus(const Value: TOnFocus);
begin
 FMC.MF.OnFocus := Value;
end;

procedure TPSDBTreeView.SetSortIndexField(const Value: string);
begin
 fmc.DBFields.sortIndex := Value;
end;

end.
