unit uPSDBTreeView.MainFrame;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ComCtrls, System.ImageList, Vcl.ImgList, Vcl.AppEvnts;

type
TOnFocus = procedure (ASender:TObject) of object;


type
  TPSDBTreeViewMainFrame = class(TFrame)
    TreeView: TTreeView;
    ilFoldersAndFiles16: TImageList;
    ilCheckboxes16: TImageList;
    ApplicationEvents: TApplicationEvents;
    procedure TreeViewExpanding(Sender: TObject; Node: TTreeNode; var AllowExpansion: Boolean);
    procedure TreeViewChange(Sender: TObject; Node: TTreeNode);
    procedure TreeViewClick(Sender: TObject);
    procedure TreeViewMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);


  private
    { Private declarations }

    FOnFocus:TOnFocus;

  public
    { Public declarations }

    constructor Create(AOwner: TComponent); override;
    property    OnFocus:TOnFocus read FOnFocus write FOnFocus;

  end;

implementation

uses  uPSDBTreeView.MC;


{$R *.dfm}

{ TPSDBTreeViewMainFrame }



constructor TPSDBTreeViewMainFrame.Create(AOwner: TComponent);
var mc:TPSDBTreeViewMC;
begin

  inherited;

//mc:=(Self.Owner as TPSDBTreeViewMC);
//MC.Checkboxes.UncheckAllChecked;
//TreeView.OnMouseMove:=mc.Checkboxes.DBTreeViewMouseMove;

end;

procedure TPSDBTreeViewMainFrame.TreeViewChange(Sender: TObject; Node: TTreeNode);
var mc:TPSDBTreeViewMC;
begin

mc:=(Self.Owner as TPSDBTreeViewMC);
if Node=nil then Exit;


  if   MC.CommonMethods.IsFolderByID( Integer(Node.data^) ) then begin

  Node.ImageIndex:=1;
  Node.OverlayIndex:=1;
  Node.SelectedIndex:=1;

  end else begin

  Node.ImageIndex:=0;
  Node.OverlayIndex:=0;
  Node.SelectedIndex:=0;

  end;



end;

procedure TPSDBTreeViewMainFrame.TreeViewClick(Sender: TObject);
var mc:TPSDBTreeViewMC;
    i: Integer;
    node:TTreeNode;
begin

mc:=(Self.Owner as TPSDBTreeViewMC);
if Assigned(FOnFocus) then FOnFocus( Self.Owner.Owner );


with MC.Checkboxes do begin
ToggleSelectedCheckBox;
end;

if TreeView.Selected<>nil then begin

     TreeView.Selected.SelectedIndex:=TreeView.Selected.ImageIndex;
     TreeView.Selected.OverlayIndex:=TreeView.Selected.ImageIndex;
end;


if not (MC.Checkboxes.IsMiceUnderNode) then

begin
MC.Checkboxes.UncheckAllChecked;
TreeView.Selected:=nil;

for i := 0 to High(mc.GetSelectedElements.IDSelectedArray) do begin
node:=mc.CommonMethods.FindNodeById(mc.GetSelectedElements.IDSelectedArray[i],mc.MF.TreeView);
node.Cut:=False;
end;


end;


//if TreeView.GetNodeAt(X,Y)=nil then ShowMessage('Hello)');

//TreeView.Selected.SelectedIndex:=1;
//TreeView.Selected.OverlayIndex:=1;

end;





procedure TPSDBTreeViewMainFrame.TreeViewExpanding(Sender: TObject; Node: TTreeNode; var AllowExpansion: Boolean);
var mc:TPSDBTreeViewMC;
begin

mc:=(Self.Owner as TPSDBTreeViewMC);
mc.Update.UpdateNodeOnExpanding(Node);
if TreeView.Images<>nil then Node.ImageIndex:=1;

end;

procedure TPSDBTreeViewMainFrame.TreeViewMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
var mc:TPSDBTreeViewMC;

begin
//


mc:=(Self.Owner as TPSDBTreeViewMC);

with TreeView do begin

mc.Checkboxes.NodeUnderMice:=nil;
if GetNodeAt(X,Y)<>nil then mc.Checkboxes.NodeUnderMice:=GetNodeAt(X,Y);


    if mc.Checkboxes.NodeUnderMice<>nil then begin

    if (X<mc.Checkboxes.NodeUnderMice.DisplayRect(true).Left-16) and
    (X>mc.Checkboxes.NodeUnderMice.DisplayRect(true).Left-32)
     then

        begin
        mc.Checkboxes.MouseOnCheckBox:=true;
        //showmessage('Here');
        end

        else mc.Checkboxes.MouseOnCheckBox:=false;

    end;



              //        ?
 if GetNodeAt(X,Y)<>nil then

 begin

 if (X<=mc.Checkboxes.NodeUnderMice.DisplayRect(true).Left+
 mc.Checkboxes.NodeUnderMice.DisplayRect(true).Width)

 then
 mc.Checkboxes.IsMiceUnderNode:=true else mc.Checkboxes.IsMiceUnderNode:=false

 end else mc.Checkboxes.IsMiceUnderNode:=false;




end;


end;

end.
