unit uPSDBTreeView.Add;

interface

uses
  System.SysUtils, System.Classes, Vcl.ComCtrls;

type
  TPSDBTreeViewAdd = class(TDataModule)
  private

    procedure SetupSelectedNodeAndCurrentParent(var ANode: TTreeNode);
    function GetNameByID(Aid: integer): string;

    { Private declarations }
  public
    { Public declarations }

    procedure AddFolder(Aname: string);
    procedure AddFile(Aname: string);

    procedure AddFileOnlyToTree(Aid: Integer; AParentNode: TTreeNode);
    procedure AddFolderOnlyToTree(Aid: Integer; AParentNode: TTreeNode);

  end;

//var
//  PSDBTreeViewAdd: TPSDBTreeViewAdd;

implementation

uses uPSDBTreeView.MC;
{%CLASSGROUP 'Vcl.Controls.TControl'}

{$R *.dfm}

procedure TPSDBTreeViewAdd.SetupSelectedNodeAndCurrentParent(var ANode: TTreeNode);

var mc:TPSDBTreeViewMC;

begin
mc:=Self.Owner as TPSDBTreeViewMC;


    ANode:=nil;
    MC.idCurrentParent:=-1;

    if (Assigned(mc.MF.TreeView.Selected)) and (Assigned(mc.MF.TreeView.Selected.Data)) then

      begin

      ANode := mc.MF.TreeView.Selected;
      MC.idCurrentParent := Integer(ANode.Data^);

      end;


end;



procedure TPSDBTreeViewAdd.AddFolder(Aname: string);

var Node:TTreeNode;
    idInserted:integer;
    idInsertedPointer:^Integer;
    AddedNode:TTreeNode;
    mc:TPSDBTreeViewMC;

begin
mc:=Self.Owner as TPSDBTreeViewMC;
//
SetupSelectedNodeAndCurrentParent(Node);


with MC do begin

// add only to folder
if Node<>nil then begin
if not CommonMethods.IsFolderByID(  Integer(Node.Data^) ) then Exit;
end;

if IsUseExternalID then

SQL.SetAddRecordSQLText(

     idCurrentParent.ToString,
     Aname,
     '0', // index
     '1', //isFolder
     '0', //isTrash
     external_id_value
    )

else

SQL.SetAddRecordSQLText(

     idCurrentParent.ToString,
     Aname,
     '0', // index
     '1', //isFolder
     '0' //isTrash
    );

SQL.qAddRecord.Connection:=mc.FDConnection;
SQL.qAddRecord.ExecSQL;



//add to tree if it is open
//with (FMainFrame as TPSDBTreeExplorerMainFrame) do begin

SQL.qGetLastInsertedID.Connection:=mc.FDConnection;
idInserted:=SQL.GetMaxID;
new(idInsertedPointer);
idInsertedPointer^:=idInserted;

if mc.mf.TreeView.Selected=nil then begin
AddedNode:= mc.mf.TreeView.Items.AddChildObject(nil,Aname,idInsertedPointer);
AddedNode.StateIndex:=1;
AddedNode.ImageIndex:=1;
AddedNode.OverlayIndex:=1;
AddedNode.SelectedIndex:=1;

end else

if (mc.mf.TreeView.Selected<>nil)  then

begin


AddedNode:=mc.mf.TreeView.Items.AddChildObject(mc.mf.TreeView.Selected,Aname,idInsertedPointer);
if not mc.mf.TreeView.Selected.Expanded then mc.mf.TreeView.Selected.Expand(false);
AddedNode.StateIndex:=1;
AddedNode.ImageIndex:=1;
AddedNode.OverlayIndex:=1;
AddedNode.SelectedIndex:=1;

end;

end;


  //resort children
 mc.Update.ResortChildren;


  with mc.Update do begin

  //update other fields in table
   if Assigned(UpdateOtherFieldsInTable) then UpdateOtherFieldsInTable(Self);

  end;




end;








procedure TPSDBTreeViewAdd.AddFile(Aname: string);

var Node:TTreeNode;
    idInserted:integer;
    idInsertedPointer:^Integer;
    AddedNode:TTreeNode;
    mc:TPSDBTreeViewMC;

begin
mc:=Self.Owner as TPSDBTreeViewMC;
//
SetupSelectedNodeAndCurrentParent(Node);


with MC do begin

// add only to folder
if Node<>nil then begin
if not CommonMethods.IsFolderByID(  Integer(Node.Data^) ) then Exit;
end;

if IsUseExternalID then

SQL.SetAddRecordSQLText(

     idCurrentParent.ToString,
     Aname,
     '0', // index
     '0', //isFolder
     '0', //isTrash
     external_id_value
    )

else

SQL.SetAddRecordSQLText(

     idCurrentParent.ToString,
     Aname,
     '0', // index
     '0', //isFolder
     '0' //isTrash
    );


SQL.qAddRecord.Connection:=mc.FDConnection;
SQL.qAddRecord.ExecSQL;



//add to tree if it is open
//with (FMainFrame as TPSDBTreeExplorerMainFrame) do begin

SQL.qGetLastInsertedID.Connection:=mc.FDConnection;
idInserted:=SQL.GetMaxID;
new(idInsertedPointer);
idInsertedPointer^:=idInserted;

if mc.mf.TreeView.Selected=nil then begin
AddedNode:= mc.mf.TreeView.Items.AddChildObject(nil,Aname,idInsertedPointer);
AddedNode.StateIndex:=1;
AddedNode.ImageIndex:=0;
AddedNode.OverlayIndex:=0;
AddedNode.SelectedIndex:=0;

end else

if (mc.mf.TreeView.Selected<>nil)  then

begin


AddedNode:=mc.mf.TreeView.Items.AddChildObject(mc.mf.TreeView.Selected,Aname,idInsertedPointer);
if not mc.mf.TreeView.Selected.Expanded then mc.mf.TreeView.Selected.Expand(false);
AddedNode.StateIndex:=1;
AddedNode.ImageIndex:=0;
AddedNode.OverlayIndex:=0;
AddedNode.SelectedIndex:=0;

end;

end;


  //resort children
 mc.Update.ResortChildren;


  with mc.Update do begin

  //update other fields in table
   if Assigned(UpdateOtherFieldsInTable) then UpdateOtherFieldsInTable(Self);

  end;




end;




procedure TPSDBTreeViewAdd.AddFileOnlyToTree(Aid: Integer; AParentNode:TTreeNode);
var
  AddedNode: TTreeNode;
  idPointer:^integer;
  NodeName:string;
  mc:TPSDBTreeViewMC;

begin

mc:=Self.Owner as TPSDBTreeViewMC;

new(idPointer);
idPointer^:=Aid;
//
with mc do begin

NodeName:=GetNameByID(Aid);

AddedNode:=mf.TreeView.Items.AddChildObject(AParentNode,NodeName,idPointer);
AddedNode.StateIndex:=1;
AddedNode.ImageIndex:=0;
AddedNode.OverlayIndex:=0;
AddedNode.SelectedIndex:=0;

end;

end;



procedure TPSDBTreeViewAdd.AddFolderOnlyToTree(Aid: Integer; AParentNode:TTreeNode);
var
  AddedNode: TTreeNode;
  idPointer:^integer;
  NodeName:string;
  mc:TPSDBTreeViewMC;

begin

mc:=Self.Owner as TPSDBTreeViewMC;
new(idPointer);
idPointer^:=Aid;
//
with mc do begin

NodeName:=GetNameByID(Aid);

AddedNode:=mf.TreeView.Items.AddChildObject(AParentNode,NodeName,idPointer);
AddedNode.StateIndex:=1;
AddedNode.ImageIndex:=1;
AddedNode.OverlayIndex:=1;
AddedNode.SelectedIndex:=1;

end;

end;



function TPSDBTreeViewAdd.GetNameByID(Aid:integer): string;

var Name_fieldWithoutQuotes:string;
    mc:TPSDBTreeViewMC;

begin
//

mc:=Self.Owner as TPSDBTreeViewMC;

with MC do begin

SQL.SetSelectWhereIDSQLtext(Aid.ToString);

with SQL.qSelectWhereID do begin

connection:=mc.fdconnection;

Open();
Name_fieldWithoutQuotes:=StringReplace(mc.SQL.Name_field,'`','',[rfReplaceAll]);
Result:=FieldByName(Name_fieldWithoutQuotes).AsString;
Close();
end;


end;


end;

end.
