unit uPSDBTreeView.CommonMethods;

interface

uses
  System.SysUtils, System.Classes, Vcl.ComCtrls;

type
  TPSDBTreeViewCommonMethods = class(TDataModule)
  private

    { Private declarations }
  public
    { Public declarations }

    function FindNodeById(Aid: integer; ATreeView:TTreeView ): TTreeNode;
    function IsFolderByID(Aid: integer): boolean;
    function IfSuchChildExists(ANode: TTreeNode; AidOfChild: integer): boolean;

  end;

//var
//  PSDBTreeViewCommonMethods: TPSDBTreeViewCommonMethods;

implementation

uses uPSDBTreeView.MC;

{%CLASSGROUP 'Vcl.Controls.TControl'}

{$R *.dfm}

{ TPSDBTreeViewCommonMethods }

function TPSDBTreeViewCommonMethods.FindNodeById(Aid: integer; ATreeView: TTreeView): TTreeNode;
var Node:TTreeNode;

begin
  Result:=nil;
  Node:=ATreeView.Items.GetFirstNode;

  if Node=nil then begin
  Result:=nil;
  Exit;
  end;

  repeat
    if Node.Data<>nil then begin
      if Aid=Integer(Node.Data^) then
       begin
       Result:=Node;
       Break;
       end;
    end;
  Node:=Node.GetNext;
  until not Assigned(Node) ;

end;


function TPSDBTreeViewCommonMethods.IsFolderByID(Aid: integer): boolean;
var mc:TPSDBTreeViewMC;
begin
//
  mc:=(Self.Owner as TPSDBTreeViewMC);
  mc.SQL.SetSelectWhereIDSQLtext(Aid.ToString);

  with MC.SQL.qSelectWhereID do begin
    Connection:=mc.FDConnection;
    Open();
    Result:=FieldByName('isFolder').AsBoolean;
    Close();
  end;

end;



function TPSDBTreeViewCommonMethods.IfSuchChildExists(ANode:TTreeNode; AidOfChild: integer):boolean;
var StartLevel:Integer;
begin

  Result:=false;
  if ANode=nil then exit;
  StartLevel:=ANode.Level;

  repeat

  if (Assigned(ANode)) and (Assigned(ANode.Data)) then

   begin

   if AidOfChild=Integer(ANode.Data^) then
   begin
   Result:=true;
   Break;
   end;

   end;


  ANode:=ANode.GetNext;
  until (not Assigned(ANode) ) or (ANode.Level<=StartLevel);

end;


end.
