unit uPSDBTreeView.CopyCutPaste;

interface

uses
  System.SysUtils, System.Classes, Vcl.ComCtrls;

type
TOnExternalInsertSelect=procedure ( AIDListSelected,AIDListInserted:Tarray<integer>  ) of object;

TOnCopyCut=procedure (AIDSelectedArray:Tarray<integer>  ) of object;

type
  TPSDBTreeViewCopyCutPaste = class(TDataModule)
  private
    { Private declarations }
    FOnExternalInsertSelect:TOnExternalInsertSelect;
    FOnCopyCut:TOnCopyCut;

    FidTarget:Integer;
    FDeleteAfterCut:Boolean;

    FIDInsertedArray:TArray<integer>;
    FIDSelectedArray:TArray<integer>;
    FTreeView:TTreeView;

    function GetParent(Aid:integer):integer;

  public
    { Public declarations }
    procedure Copy;
    procedure Cut;
    procedure Paste;

    property IDInsertedArray:TArray<integer> read FIDInsertedArray write FIDInsertedArray;
    property OnExternalInsertSelect:TOnExternalInsertSelect read FOnExternalInsertSelect write FOnExternalInsertSelect;
    property OnCopyCut:TOnCopyCut read FOnCopyCut write FOnCopyCut;
    property DeleteAfterCut:Boolean read FDeleteAfterCut write FDeleteAfterCut;
    property TreeView:TTreeView read FTreeView write FTreeView;

  end;

//var
//  PSDBTreeViewCopyCutPaste: TPSDBTreeViewCopyCutPaste;

implementation

{%CLASSGROUP 'Vcl.Controls.TControl'}

{$R *.dfm}

uses uPSDBTreeView.MC;

{ TPSDBTreeViewCopyCutPaste }



procedure TPSDBTreeViewCopyCutPaste.Copy;
var mc:TPSDBTreeViewMC;
begin
mc:=(Self.Owner as TPSDBTreeViewMC);
mc.GetSelectedElements.Execute;
FIDSelectedArray:=mc.GetSelectedElements.IDSelectedArray;
if Assigned(FOnCopyCut) then FOnCopyCut(FIDSelectedArray);
end;

procedure TPSDBTreeViewCopyCutPaste.Cut;
var mc:TPSDBTreeViewMC;
    i: Integer;
    node:TTreeNode;
begin
FDeleteAfterCut:=true;
mc:=(Self.Owner as TPSDBTreeViewMC);
mc.GetSelectedElements.Execute;
FIDSelectedArray:=mc.GetSelectedElements.IDSelectedArray;
if Assigned(FOnCopyCut) then FOnCopyCut(FIDSelectedArray);

for i := 0 to High(mc.GetSelectedElements.IDSelectedArray) do begin
node:=mc.CommonMethods.FindNodeById(mc.GetSelectedElements.IDSelectedArray[i],mc.MF.TreeView);
node.Cut:=true;
end;


end;



procedure TPSDBTreeViewCopyCutPaste.Paste;
var
  i: Integer;

  IDParentOfSelected:integer;
  j: integer;
  idNewParentForInserted: integer;
  TargetNode: TTreeNode;
  mc:TPSDBTreeViewMC;
  external_id_value_selected: integer;
  External_id_field_WithoutQuotes: string;
  external_id_value_inserted: integer;

begin

mc:=(Self.Owner as TPSDBTreeViewMC);

//setting FIDTarget
if Assigned(mc.MF.TreeView.Selected) then
FidTarget:=Integer(mc.MF.TreeView.Selected.Data^) else
FidTarget:=-1;

//cnecks cannot paste in file
if (not MC.CommonMethods.IsFolderByID(FidTarget))
and (FidTarget<>-1)
then Exit();

// copy records externally
if Assigned(FOnExternalInsertSelect) then FOnExternalInsertSelect(FIDSelectedArray,FIDInsertedArray)

else begin
// copy only idParent, sortIndex,name,isFolder,isTrash,isChecked fields...

//checks - cannot paste in self
SetLength(FIDInsertedArray,0);

  with MC do begin

      for i := 0 to High(GetSelectedElements.IDSelectedArray) do begin
      if GetSelectedElements.IDSelectedArray[i]=FidTarget then
       begin
         raise Exception.Create('Error Message - Cannot paste in itself');
       end;
      end;


      // insert to DB
      for i := 0 to High(GetSelectedElements.IDSelectedArray) do

      begin
      {
      if IsUseExternalID then
      SQL.
      SetInsertSelectSQLText(GetSelectedElements.IDSelectedArray[i].ToString,External_id_value) else
      SQL.
      SetInsertSelectSQLText(GetSelectedElements.IDSelectedArray[i].ToString)
      ;
      SQL.qInsertSelect.Connection:=mc.FDConnection;
      SQL.qInsertSelect.ExecSQL;
      }
      SQL.SetInsertSelectSQLText2(GetSelectedElements.IDSelectedArray[i]);
      SQL.qInsertSelect2.ExecSQL;

      // add last id to array
      SQL.qGetLastInsertedID.Connection:=mc.FDConnection;
      SetLength(FIDInsertedArray,Length(IDInsertedArray)+1);
      IDInsertedArray[Length(FIDInsertedArray)-1]:=SQL.GetMaxID;

      end;



  end;

end;

{
-give selected ID outside as event with params
-copy there all fields
-return success and continue restructure here
}



//copy in db !!! BETTER DO THAT FROM OUTSIDE
// BECAUSE WE DONT KNOW ALL THE FIELDS AND HERE
// WE JUST CAN USE EVENT WITH IDLISTSELECTED AND IDLISTINSERTED AS PARAMS


with MC do begin



// reparenting

  for i := 0 to High(GetSelectedElements.IDSelectedArray) do begin

      IDParentOfSelected:=GetParent(GetSelectedElements.IDSelectedArray[i]);


          idNewParentForInserted:=-2;
      // find index of IDParentOfSelected in GetSelectedElements.IDSelectedArray[i]
          for j := 0 to High(GetSelectedElements.IDSelectedArray) do begin
          if IDParentOfSelected=GetSelectedElements.IDSelectedArray[j] then
           begin
            idNewParentForInserted:=IDInsertedArray[j];
            Break;
           end;

          end;
          if idNewParentForInserted=-2 then idNewParentForInserted:=FIDTarget;



        //set new parent
        with SQL do begin
        SetUpdateParentSQLText(idNewParentForInserted.ToString,IDInsertedArray[i].ToString);
        qUpdateParent.Connection:=mc.fdConnection;
        qUpdateParent.ExecSQL;
        end;


      //add new nodes in tree
      TargetNode:=CommonMethods.FindNodeById(idNewParentForInserted,mc.mf.TreeView);

       begin

       if CommonMethods.IsFolderByID(IDInsertedArray[i])
       then AddFolderOrFile.AddFolderOnlyToTree(IDInsertedArray[i],TargetNode)
        else AddFolderOrFile.AddFileOnlyToTree(IDInsertedArray[i],TargetNode);
       //AddFolderOrFile.AddFile(IDInsertedArray[i]);

       end;

  end;



end;


//reparent new records in db theory

{
ArrOrder   id idParent
0           1   -1
1           2    1
2           3    1
..
17          17   1

// After insert
ArrOrder  id     idParent
0          4    ?
1          5    ?
2          6    ?
..
17         17   ?

update all inserted idParent to new root Parent, for ex. new root idParent=7

// After insert
ArrOrder  id idParent
0          4    7
1          5    7
2          6    7

after - reparent comparing parent orders

}

// check if paste to other tree then change external_id
// check if FIDSelected[i] and FIDInserted[i] external_id the same

if (Length(FIDInsertedArray)>0) then begin

//
      with mc.SQL do begin

          // getting inserted

          SetSelectWhereIDSQLtext(FIDInsertedArray[0].ToString);
          qSelectWhereID.Connection:=mc.FDConnection;
          qSelectWhereID.Open();
          External_id_field_WithoutQuotes:=StringReplace(mc.SQL.External_id_field,'`','',[rfReplaceAll, rfIgnoreCase]);
          external_id_value_inserted:=qSelectWhereID.FieldByName(External_id_field_WithoutQuotes).AsInteger;
          qSelectWhereID.Close();


          // update external id
          if external_id_value_inserted<>mc.External_id_value then begin

           for i := 0 to High(FIDInsertedArray) do begin

            SetUpdateExternalIDWhereIDSQLText(FIDInsertedArray[i],mc.External_id_value);
            qUpdateExternalIDWhereID.Connection:=mc.FDConnection;
            qUpdateExternalIDWhereID.ExecSQL;

           end;


          end;

         mc.Update.ResortChildren;
      end;


  end;


if FTreeView=nil then FTreeView:=mc.MF.TreeView;

//
if FDeleteAfterCut then begin
 for i := 0 to High(mc.GetSelectedElements.IDSelectedArray) do
   mc.Delete.DeleteSomeNode(mc.GetSelectedElements.IDSelectedArray[i],FTreeView);
end;

end;



function TPSDBTreeViewCopyCutPaste.GetParent(Aid: integer): integer;
var idParent_field_withoutQuotes:string;
    mc:TPSDBTreeViewMC;
begin

mc:=(Self.Owner as TPSDBTreeViewMC);
//
  with MC.SQL do begin
  SetSelectWhereIDSQLtext(Aid.ToString);
    with qSelectWhereID do begin
     Open();
     idParent_field_withoutQuotes:=StringReplace(idParent_field,'`','',[rfReplaceAll]);
     Result:=FieldByName( idParent_field_withoutQuotes ).AsInteger;
     Close();
    end;

  end;

end;

end.
