unit uPSDBTreeView.Delete;

interface

uses
  System.SysUtils, System.Classes, Vcl.ComCtrls;

type
  TPSDBTreeViewDelete = class(TDataModule)
    procedure DataModuleDestroy(Sender: TObject);
  private

    FIDArrayChildrenToDelete:array of integer;



    procedure GatherAllChildrenID(Aid: integer);
    procedure DeleteRecordFromDB(Aid: integer);


    { Private declarations }
  public
    { Public declarations }
    procedure DeleteCheckedOrSelected;

    procedure DeleteSomeNode(ANode: TTreeNode); overload;
    procedure DeleteSomeNode(AID: integer; ATreeView:TTreeView); overload;

    procedure ClearOnlyGhostChild(Node: TTreeNode);
    procedure ClearAllPointers;
  end;

//var
//  PSDBTreeViewDelete: TPSDBTreeViewDelete;



implementation

{%CLASSGROUP 'Vcl.Controls.TControl'}

{$R *.dfm}
uses uPSDBTreeView.Update,
     uPSDBTreeView.MC;

procedure TPSDBTreeViewDelete.ClearOnlyGhostChild(Node:TTreeNode);
begin
if Node=nil then Exit;
if Node.Item[0].Text=SomeGhostNodeConst then Node.Item[0].Delete;
end;



procedure TPSDBTreeViewDelete.DataModuleDestroy(Sender: TObject);
begin
//ClearAllPointers;
end;

procedure TPSDBTreeViewDelete.DeleteCheckedOrSelected;

var i:integer;
    Node:TTreeNode;
    mc:TPSDBTreeViewMC;

begin

mc:=(Self.Owner as TPSDBTreeViewMC);


with MC do begin
MF.TreeView.Items.BeginUpdate;
GetSelectedElements.Execute;
for i:=High(GetSelectedElements.IDSelectedArray) downto 0  do begin
Node:=CommonMethods.FindNodeById(GetSelectedElements.IDSelectedArray[i],mc.MF.TreeView);
if Node<>nil then DeleteSomeNode(Node);
MF.TreeView.Items.EndUpdate;
end;





//end;

end;
end;




procedure TPSDBTreeViewDelete.DeleteSomeNode(ANode: TTreeNode);
var id:integer;

    i: Integer;
    TempNode:TTreeNode;
    mc:TPSDBTreeViewMC;

begin

  mc:=(Self.Owner as TPSDBTreeViewMC);

 try

  if (ANode=nil)then Exit;
  if ANode.Data=nil then Exit;


  id:=integer(ANode.data^);
  SetLength(FIDArrayChildrenToDelete,0); // !!! here because of recursion
  GatherAllChildrenID( id );
  for i := 0 to High(FIDArrayChildrenToDelete) do
  DeleteRecordFromDB(FIDArrayChildrenToDelete[i]);


   with mc.mf.TreeView do begin

      Items.BeginUpdate;

        ANode.DeleteChildren;

        //deleting itself
        DeleteRecordFromDB(id);
        Dispose(ANode.Data); // deleted and niled above
      //  Node.Data:=nil;
        ANode.Delete;
        ANode:=nil;

      Items.EndUpdate;

   end;

 except

 on E:Exception do
 raise Exception.Create(' ,    ');

 end;

end;



procedure TPSDBTreeViewDelete.DeleteSomeNode(AID: integer; ATreeView:TTreeView);
var i: Integer;
    TempNode:TTreeNode;
    mc:TPSDBTreeViewMC;
    node:TTreeNode;

begin

  mc:=(Self.Owner as TPSDBTreeViewMC);

 try

  SetLength(FIDArrayChildrenToDelete,0); // !!! here because of recursion
  GatherAllChildrenID( AID );
  for i := 0 to High(FIDArrayChildrenToDelete) do
  DeleteRecordFromDB(FIDArrayChildrenToDelete[i]);

  node:=mc.CommonMethods.FindNodeById(AID,ATreeView);
  if node=nil then Exit;

   with ATreeView do begin

      Items.BeginUpdate;

        node.DeleteChildren;

        //deleting itself
        DeleteRecordFromDB(Aid);
        Dispose(node.Data); // deleted and niled above
      //  Node.Data:=nil;
        node.Delete;
        node:=nil;

      Items.EndUpdate;

   end;

 except

 on E:Exception do
 raise Exception.Create(' ,    ');

 end;

end;

procedure TPSDBTreeViewDelete.DeleteRecordFromDB(Aid: integer);
var  mc:TPSDBTreeViewMC;
begin
mc:=(Self.Owner as TPSDBTreeViewMC);

    //delete from db
     with MC.SQL do begin
     SetDeleteWhereIDSQLText(Aid.ToString);
     qDeleteWhereID.Connection:=mc.FDConnection;
     qDeleteWhereID.ExecSQL;
     end;


end;


procedure TPSDBTreeViewDelete.GatherAllChildrenID(Aid: integer);

var LocalIDArray:array of integer;
  i: Integer;
  mc:TPSDBTreeViewMC;
begin
mc:=(Self.Owner as TPSDBTreeViewMC);
//select all children from db
 MC.SQL.SetSelectAllChildrenOrderedSQLText(Aid.ToString,'0');

//gather their id

with MC.SQL.qSelectAllChildrenOrdered do begin

  Open();
  SetLength(LocalIDArray,0);

  while not EOF do begin

   // adding final array
   SetLength(FIDArrayChildrenToDelete,Length(FIDArrayChildrenToDelete)+1);
   FIDArrayChildrenToDelete[Length(FIDArrayChildrenToDelete)-1]:=FieldByName('id').AsInteger;

   //LocalIDArray
   SetLength(LocalIDArray,Length(LocalIDArray)+1);
   LocalIDArray[Length(LocalIDArray)-1]:=FieldByName('id').AsInteger;


  Next();
  end;


  Close();


 end;

//call recursievely itself
for i := 0 to High(LocalIDArray)  do begin
GatherAllChildrenID(LocalIDArray[i]);
end;


end;






procedure TPSDBTreeViewDelete.ClearAllPointers;
var Node:TTreeNode;
    mc:TPSDBTreeViewMC;

begin

mc:=(Self.Owner as TPSDBTreeViewMC);

with mc do begin

Node:=mc.MF.TreeView.Items.GetFirstNode;
if Node=nil then Exit;


      repeat
        // DoSomething with Tree for Example
      //  Node.Text:='Was here during travesing';

        Dispose(Node.Data);
        Node:=Node.GetNext;

      until not Assigned(Node) ;


end;



end;




end.
