unit uPSDBTreeView.GetSelectedElements;

interface

uses
  System.SysUtils, System.Classes;

type
  TPSDBTreeViewGetSelectedElements = class(TDataModule)
  private
    { Private declarations }
    FIDSelectedArray:Tarray<integer>;

    procedure GatherAllChildrenInDB(AidParent: integer);


  public
    { Public declarations }
    function Execute: TArray<integer>;
    property IDSelectedArray:TArray<integer> read FIDSelectedArray
    write FIDSelectedArray;

  end;

//var
//  PSDBTreeViewGetSelectedElements: TPSDBTreeViewGetSelectedElements;

implementation

uses
  Vcl.ComCtrls,uPSDBTreeView.MC;

{%CLASSGROUP 'Vcl.Controls.TControl'}

{$R *.dfm}


function TPSDBTreeViewGetSelectedElements.Execute: TArray<integer>;

var Node:TTreeNode;
    mc:TPSDBTreeViewMC;

begin

mc:=Self.Owner as TPSDBTreeViewMC;

// first check all checked nodes

SetLength(FIDSelectedArray,0);

with mc.mf.TreeView do begin

Node:=Items.GetFirstNode;

  if Assigned(Node) then begin

    repeat

     if (Node.StateIndex=2) and (Node.Data<>nil) then begin

      SetLength(FIDSelectedArray,Length(FIDSelectedArray)+1);
      FIDSelectedArray[Length(FIDSelectedArray)-1]:=Integer(Node.Data^);

    end;

    Node:=Node.GetNext;
    until not Assigned(Node) ;

  end;

// if nothing checked
  if Length(FIDSelectedArray)=0 then

  begin

    if (Selected<>nil) and Assigned(Selected.Data) then

    begin
     // if just file
     if not   mc.CommonMethods.IsFolderByID(integer(Selected.Data^))

       then begin

       SetLength(FIDSelectedArray,Length(FIDSelectedArray)+1);
       FIDSelectedArray[Length(FIDSelectedArray)-1]:=integer(Selected.Data^);

       end else

     // if is folder recursievely gather all id
       begin


         //Gathering id of selected
         SetLength(FIDSelectedArray,Length(FIDSelectedArray)+1);
         FIDSelectedArray[Length(FIDSelectedArray)-1]:=integer(Selected.Data^);

         //Gathering id of all children of all levels of selected
          GatherAllChildrenInDB(integer(Selected.Data^));

       end;



    end;

  end;




end;


end;



procedure TPSDBTreeViewGetSelectedElements.GatherAllChildrenInDB(AidParent: integer);

var id_fieldWithoutQuotes:String;
    IDArrayLocal:array of integer;
    i: Integer;
    mc:TPSDBTreeViewMC;

begin


mc:=Self.Owner as TPSDBTreeViewMC;
//
  with MC do begin

  SQL.SetSelectAllChildrenOrderedSQLText(AidParent.ToString,'0');

    with SQL.qSelectAllChildrenOrdered do begin

    id_fieldWithoutQuotes:=StringReplace(mc.SQL.id_field,'`','',[rfReplaceAll]);

     Open();

     SetLength(IDArrayLocal,0);
     while not EOF do begin


       SetLength(IDArrayLocal,Length(IDArrayLocal)+1);
       IDArrayLocal[Length(IDArrayLocal)-1]:=FieldByName(id_fieldWithoutQuotes).AsInteger;

       SetLength(FIDSelectedArray,Length(FIDSelectedArray)+1);
       FIDSelectedArray[Length(FIDSelectedArray)-1]:=FieldByName(id_fieldWithoutQuotes).AsInteger;

     Next();
     end;

     Close();

    end;


  end;


  for i := 0 to High(IDArrayLocal) do begin
  GatherAllChildrenInDB(IDArrayLocal[i]);
  end;


end;

end.
