unit uPSDBTreeView.NodeUpDown;

interface

uses
  System.SysUtils, System.Classes, Vcl.ComCtrls;

type
  TPSDBTreeViewNodeUpDown = class(TDataModule)
  private
    procedure UpdateStateIndex(Node: TTreeNode);
    procedure ExchangeSortIndexesInDB(Aid1, Aid2: integer);
    function GetSortIndexFromDB(Aid: integer): integer;
    { Private declarations }
  public
    { Public declarations }

    procedure NodeUp;
    procedure NodeDown;

  end;

//var
//  PSDBTreeViewNodeUpDown: TPSDBTreeViewNodeUpDown;

implementation

{%CLASSGROUP 'Vcl.Controls.TControl'}

{$R *.dfm}

uses uPSDBTreeView.MC;






procedure TPSDBTreeViewNodeUpDown.NodeUp;
var
  CurrentNode: TTreeNode;
  BeforeNode: TTreeNode;

    IndexesCurrentNode:TArray<integer>;
    IndexesBeforeNode:TArray<integer>;

    BeforeNode_id,CurrentNode_id:integer;
    mc:TPSDBTreeViewMC;

begin
//
mc:=(Self.Owner as TPSDBTreeViewMC);

with mc.MF.TreeView do begin

//
 if (Selected=nil) or (Selected.getPrevSibling=nil) then exit;

   CurrentNode:=Selected;
   BeforeNode:=CurrentNode.GetPrevChild(CurrentNode);
   CurrentNode.MoveTo(BeforeNode,naInsert);

   SetFocus;
   CurrentNode.Selected:=true;

   //resort all children of Selected.Parent
   UpdateStateIndex(CurrentNode);
   UpdateStateIndex(BeforeNode);

   //Exchange indexes;
CurrentNode_id:=Integer(CurrentNode.Data^);
BeforeNode_id:=Integer(BeforeNode.Data^);

ExchangeSortIndexesInDB(CurrentNode_id,BeforeNode_id);


end;


end;


procedure TPSDBTreeViewNodeUpDown.NodeDown;
var
  CurrentNode: TTreeNode;
  AfterNode: TTreeNode;
  IndexesCurrentNode:TArray<integer>;
  IndexesAfterNode:TArray<integer>;
  CurrentNode_id,AfterNode_id:integer;
  mc:TPSDBTreeViewMC;
begin
//
mc:=(Self.Owner as TPSDBTreeViewMC);
with mc.mf.TreeView do begin

//
 if (Selected=nil) or (Selected.getNextSibling=nil) then exit;

   CurrentNode:=Selected;
   AfterNode:=CurrentNode.GetNextChild(CurrentNode);
   AfterNode.MoveTo(CurrentNode,naInsert);


   SetFocus;
   CurrentNode.Selected:=true;

   //resort all children of Selected.Parent
UpdateStateIndex(CurrentNode);
UpdateStateIndex(AfterNode);


//Exchange sort indexes
CurrentNode_id:=Integer(CurrentNode.Data^);
AfterNode_id:=Integer(AfterNode.Data^);

ExchangeSortIndexesInDB(CurrentNode_id,AfterNode_id);

end;


end;



procedure TPSDBTreeViewNodeUpDown.UpdateStateIndex(Node:TTreeNode);
var i:integer;
begin

       if Node.StateIndex=2 then

       begin
       Node.StateIndex:=1;
       Node.StateIndex:=2;
       end else

       begin

       Node.StateIndex:=2;
       Node.StateIndex:=1;
       end;


      if Node.HasChildren then
       begin

       for i := 0 to Node.Count-1 do
       UpdateStateIndex(Node[i]);

       end;


end;



procedure TPSDBTreeViewNodeUpDown.ExchangeSortIndexesInDB(Aid1, Aid2: integer);

var SortIndex1,SortIndex2:Integer;
    mc:TPSDBTreeViewMC;
begin

mc:=(Self.Owner as TPSDBTreeViewMC);
SortIndex1:=GetSortIndexFromDB(Aid1);
SortIndex2:=GetSortIndexFromDB(Aid2);

  with mc.Sql do begin
  qUpdateSortIndex.Connection:=mc.FDConnection;
  SetUpdateSortIndexSQLText(SortIndex1.ToString,Aid2.ToString);
  qUpdateSortIndex.ExecSQL;
  SetUpdateSortIndexSQLText(SortIndex2.ToString,Aid1.ToString);
  qUpdateSortIndex.ExecSQL;
  end;

end;


function TPSDBTreeViewNodeUpDown.GetSortIndexFromDB(Aid: integer): integer;

var
    sortIndexWithoutQuotes:string;
    mc:TPSDBTreeViewMC;

begin

mc:=(Self.Owner as TPSDBTreeViewMC);

  with mc.SQL do begin
  SetSelectWhereIDSQLtext(Aid.ToString);
  qSelectWhereID.Open();
  sortIndexWithoutQuotes:=StringReplace(SortIndex_field,'`','',[rfReplaceAll, rfIgnoreCase]);
  Result:=qSelectWhereID.FieldByName(sortIndexWithoutQuotes).AsInteger;
  end;

end;

end.
